package org.eclipse.jdt.internal.compiler.tool;

package .tmp;

import javax.tools.Diagnostic;
import javax.tools.DiagnosticListener;
import javax.tools.JavaFileObject;
import org.eclipse.jdt.core.compiler.CategorizedProblem;
import org.eclipse.jdt.internal.compiler.CompilationResult;
import org.eclipse.jdt.internal.compiler.batch.BatchCompilerRequestor;
import org.eclipse.jdt.internal.compiler.batch.Main;
import org.eclipse.jdt.internal.compiler.problem.DefaultProblemFactory;
import org.eclipse.jdt.internal.compiler.tool.EclipseDiagnostic;

public class EclipseCompilerRequestor extends BatchCompilerRequestor {
  private final DiagnosticListener<? super JavaFileObject> diagnosticListener;
  
  private final DefaultProblemFactory problemFactory;
  
  public EclipseCompilerRequestor(Main compiler, DiagnosticListener<? super JavaFileObject> diagnosticListener, DefaultProblemFactory problemFactory) {
    super(compiler);
    this.diagnosticListener = diagnosticListener;
    this.problemFactory = problemFactory;
  }
  
  protected void reportProblems(CompilationResult result) {
    if (this.diagnosticListener != null) {
      byte b;
      int i;
      CategorizedProblem[] arrayOfCategorizedProblem;
      for (i = (arrayOfCategorizedProblem = result.getAllProblems()).length, b = 0; b < i; ) {
        CategorizedProblem problem = arrayOfCategorizedProblem[b];
        EclipseDiagnostic diagnostic = EclipseDiagnostic.newInstance(problem, this.problemFactory);
        this.diagnosticListener.report((Diagnostic<? extends JavaFileObject>)diagnostic);
        b++;
      } 
    } 
  }
}
